# tjot change log

## [v0.0.4] Sun Jun 08 13:38:37 2025 -0500

### Added

- table rendering


## [v0.0.3] Sun Jun 08 10:58:36 2025 -0500

### Added

- ThematicBreak, because it was triggered by
- FootnoteDefNode
- support continuation lists (ordered lists starting > 1)
- pass symbols through to the output
- super and subscript support
- task list items
- definition lists
- more info to the node implementation coverage
- support Raw
- detection of terminal dimensions
- line breaks (backslash)
- images

### Changed

- user errors panic less.
- indentation is set-able (in code)
- deprecated library dependency
- the initial indent (padding)

### Fixed

- list handling of all inline nodes
- list handling, and works around ListItemNodes sometimes containing TextNodes, and sometimes ParagraphNodes


## [v0.0.2] Mon Jun 02 09:51:19 2025 -0500

### Added

- print the unimplemented node names
- -v verbose
- -h help
- -v version
- -c coverage
- more node types supported. Not all, but getting there.
- unit tests

### Changed

- updates to prep for godjot v2.0.0
- normalizes unimplemented node rendering
- go-term-text expects a hard reset of all styles instead of selective clearing of set styles; in the latter case, it incorrectly witnesses an unclosed style and reapplies it later. ANSI terminal codes have _inverse_ codes: for the italic code , there's an _unitalic_ code. The previous versions did this (which, rather than resetting the entire terminal with `\x1b[0m`, is the correct way to do it) but it resulted in screwed up output because of go-term-text's more broad expectations. Rather than trying to propagate even more fixes to dependencies, this commit just does sloppy resetting, too, which makes go-term-text happy.

### Fixed

- off-by-one indexing bug


## [v0.0.1] Sat May 17 12:31:12 2025 -0500

### Changed

- actually use the generic abstraction, rather than the closure reference
- Uses remodelled godjot library, so that has to be accepted before this can be released.
- The terminal rendering code -- wherever I got it from -- was incomplete. It's entirely rewritten, and mostly works. Mostly.

### Fixed

- various CI issues.
- a whole bunch of print formatting errors

## Contributors

-        Sean E. Russell <ser@ser1.net>

## Todo

1. BUG tests/README.dj level 3 isn't rendered ("Limitations") 
2. BUG djot tables can have alignment changes in the middle; this is not yet implemented 
3. BUG godjot does not yet correctly process sequential tables; this bubbles up here 
4. BUG in tests/README.dj, why is the last PP displayed as a FootnoteDef (or, list item)? 
5. REQ implement (optional) sidenotes, for wide displays 
6. REQ implement paging 
7. REQ make the build path directory configurable; this assumes main is in . 
8. REQ support all markers 
9. REQ add option to print [term] instead of trying to use unicode fonts 
10. REQ make links footnotes maybe
11. REQ If pager, then handle links with hints 
